      SUBROUTINE P1P2C(A,B,C,X,DINV,S,V,WORK,JJ,
     1  OBJ,N,M,R,MTOT,A1,B1,C1,X1,DINV1,S1,V1,
     2  WORK1,JJ1,OBJ1,N1,M1,MTOT1,JOUT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(MTOT,N),B(MTOT),C(N),X(N),
     1  DINV(N,N),S(N),V(N),WORK(N),JJ(N)
      DIMENSION A1(MTOT1,N1),B1(MTOT1),C1(N1),
     1  X1(N1),DINV1(N1,N1),S1(N1),V1(N1),
     2  WORK1(N1),JJ1(N1)
      INTEGER R,RHO
      DOUBLE PRECISION LAMBDA
      COMMON /UNITS/ IIN,IOUT
C
      TOLFES = 1.D-6
      EPS = 1.D-5
      WRITE(IOUT,8020)
      WRITE(IOUT,8000)
C
C  CHECK FOR B(I).GE.0 FOR EQUALITY CONSTRAINTS
C
      IF(R.EQ.0) GO TO 50
      DO 40 I=1,R
      IF(B(M+I).GE.0.D0) GO TO 40
      DO 30 J=1,N
   30 A(M+I,J) = - A(M+I,J)
      B(M+I) = - B(M+I)
   40 CONTINUE
   50 CONTINUE
C
C
C  CONSTRUCT PHASE 1 DATA
C  INITIAL POINT CONSTRAINT MATRIX
      DO 200 I=1,MTOT
      DO 100 J=1,N
  100 A1(I,J) = A(I,J)
  200 CONTINUE
      DO 240 I=1,M
  240 A1(I,N1) = - 1.D0
      IF(R.EQ.0) GO TO 260
      DO 250 I=1,R
  250 A1(M+I,N1) = 0.D0
  260 CONTINUE
      DO 300 I=1,N
  300 A1(M1,I) = 0.D0
      A1(M1,N1) = -1.D0
C
C  INITIAL POINT RIGHT HAND SIDE
      DO 400 I=1,MTOT
  400 B1(I) = B(I)
      B1(M1) = 0.D0
C
C  INITIAL POINT OBJECTIVE FUNCTION
      DO 500 I=1,N
  500 C1(I) = 0.D0
      C1(N1) = 1.D0
      IF(R.EQ.0) GO TO 550
      DO 540 I=1,R
      DO 530 J=1,N
  530 C1(J) = C1(J) - A(M+I,J)
  540 CONTINUE
  550 CONTINUE
C
C  INITIAL FEASIBLE POINT
      DO 600 I=1,N
  600 X1(I) = 0.D0
      ALPHA = - 1.D30
      DO 700 I=1,M
      IF(ALPHA.GT.(-B(I))) GO TO 700
      ALPHA = - B(I)
  700 CONTINUE
      ALPHA = DMAX1(0.D0,ALPHA)
      X1(N1) = ALPHA
C
C  D INVERSE AND INDEX SET
      DO 800 I=1,N1
      DO 800 J=1,N1
  800 DINV1(I,J) = 0.D0
      DO 900 I=1,N1
      DINV1(I,I) = 1.D0
  900 JJ1(I) = 0
C
C  INITIAL POINT DATA IS NOW COMPLETE:
C  USE ALGORITHM 2 TO SOLVE THE INITIAL POINT
C  PROBLEM
C
      CALL ALG2(A1,B1,C1,X1,DINV1,S1,V1,WORK1,
     1  JJ1,OBJ,N1,M1,MTOT1,JOUT)
      SUMB = 0.D0
      IF(R.EQ.0) GO TO 920
      DO 910 I=1,R
  910 SUMB = SUMB + B(M+I)
  920 CONTINUE
      IF(DABS(OBJ+SUMB).LE.TOLFES) GO TO 1000
C  NO FEASIBLE SOLUTION
      JOUT = 3
      RETURN
 1000 CONTINUE
      WRITE(IOUT,8010)
      DO 1100 I=1,N
 1100 X(I) = X1(I)
C  IS M + 1 IN THE ACTIVE SET?
      DO 1200 I=1,N1
      IF(JJ1(I).EQ.M1) GO TO 1500
 1200 CONTINUE
C  M + 1 IS NOT IN THE ACTIVE SET;
C  APPLY EXERCISE 2.26
      CCK0 = -1.D0
      K = 0
      DO 1300 I=1,N1
      IF(DABS(DINV1(N1,I)).LT.CCK0) GO TO 1300
      CCK0 = DABS(DINV1(N1,I))
      K = I
 1300 CONTINUE
      DO 1400 I=1,N
 1400 WORK1(I) = 0.D0
      WORK1(N1) = -1.D0
      CALL PHI(DINV1,WORK1,K,N1)
      JJ1(K) = M1
C  M + 1 IS NOW IN THE ACTIVE SET
 1500 CONTINUE
      IF(R.EQ.0) GO TO 2200
      IBOT = M + 1
      ITOP = M + R
      DO 2100 RHO=IBOT,ITOP
C  IS RHO IN THE ACTIVE SET?
      DO 1600 I=1,N1
      IF(JJ1(I).EQ.RHO) GO TO 2100
 1600 CONTINUE
C  EQUALITY CONSTRAINT RHO IS NOT IN
C  TRY TO PUT IT IN
      LAMBDA = -1.D0
      K = 0
      DO 1800 I=1,N1
      IF(JJ1(I).GT.M) GO TO 1800
      SUM = 0.D0
      DO 1700 J=1,N
 1700 SUM = SUM + A(RHO,J)*DINV1(J,I)
      IF(DABS(SUM).LE.LAMBDA) GO TO 1800
      LAMBDA = DABS(SUM)
      K = I
 1800 CONTINUE
      IF(LAMBDA.GE.EPS) GO TO 1900
C  HERE, EQUALITY CONSTRAINT RHO IS REDUNDANT
C  NOTE THIS ON THE OUTPUT UNIT AND CONTINUE
      WRITE(IOUT,8030) RHO
      GO TO 2100
 1900 CONTINUE
      DO 2000 I=1,N
 2000 WORK1(I) = A(RHO,I)
      WORK1(N1) = 0.D0
      CALL PHI(DINV1,WORK1,K,N1)
      JJ1(K) = RHO
 2100 CONTINUE
C
C  ALL POSSIBLE EQUALITY CONSTRAINTS ARE NOW IN
C  THE ACTIVE SET
C
 2200 CONTINUE
C
C  EXTRACT DINV FROM DINV1 AND JJ FROM JJ1
C
      NXTCOL = 1
      DO 2400 J=1,N1
      IF(JJ1(J).EQ.M1) GO TO 2400
      DO 2300 I=1,N
 2300 DINV(I,NXTCOL) = DINV1(I,J)
      JJ(NXTCOL) = JJ1(J)
      NXTCOL = NXTCOL + 1
 2400 CONTINUE
C
C  INITIAL DATA NOW COMPLETE
C
      CALL ALG3(A,B,C,X,DINV,S,V,WORK,JJ,OBJ,N,M,
     1  R,MTOT,JOUT)
      RETURN
C
 8000 FORMAT(//,20X,'PHASE 1 LP')
 8010 FORMAT(//,20X,'PHASE 2 LP')
 8020 FORMAT(10X,'PHASE 1 - PHASE 2 PROCEDURE',
     1  ' VERSION C')
 8030 FORMAT(6X,'EQUALITY CONSTRAINT',I3,
     1  ' IS REDUNDANT')
      END
